InteractionCallback (Spring Framework 3.2.1.RELEASE API)
Date: 2013-01-24

org.springframework.jca.cci.core

## Interface InteractionCallback<T>

-     public interface InteractionCallback<T>

  Generic callback interface for code that operates on a CCI Interaction. Allows to execute any number of operations on a single Interaction, for example a single execute call or repeated execute calls with varying parameters.

  This is particularly useful for delegating to existing data access code that expects an Interaction to work on and throws ResourceException. For newly written code, it is strongly recommended to use CciTemplate's more specific `execute` variants.

  Since:
    1.2
  Author:
    Thierry Templier, Juergen Hoeller
  See Also:
    `CciTemplate.execute(InteractionCallback)`, `CciTemplate.execute(javax.resource.cci.InteractionSpec, javax.resource.cci.Record)`, `CciTemplate.execute(javax.resource.cci.InteractionSpec, RecordCreator, RecordExtractor)`

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `T` | `doInInteraction(Interaction interaction, ConnectionFactory connectionFactory)` Gets called by `CciTemplate.execute` with an active CCI Interaction.

- - ### Method Detail

    - #### doInInteraction

          T doInInteraction(Interaction interaction,
                          ConnectionFactory connectionFactory)
                            throws ResourceException,
                                   SQLException,
                                   DataAccessException

      Gets called by `CciTemplate.execute` with an active CCI Interaction. Does not need to care about activating or closing the Interaction, or handling transactions.

      If called without a thread-bound CCI transaction (initiated by CciLocalTransactionManager), the code will simply get executed on the CCI Interaction with its transactional semantics. If CciTemplate is configured to use a JTA-aware ConnectionFactory, the CCI Interaction and thus the callback code will be transactional if a JTA transaction is active.

      Allows for returning a result object created within the callback, i.e. a domain object or a collection of domain objects. Note that there's special support for single step actions: see the `CciTemplate.execute` variants. A thrown RuntimeException is treated as application exception: it gets propagated to the caller of the template.

      Parameters:
        `interaction` - active CCI Interaction
        `connectionFactory` - the CCI ConnectionFactory that the Connection was created with (gives access to RecordFactory and ResourceAdapterMetaData)
      Returns:
        a result object, or `null` if none
      Throws:
        `ResourceException` - if thrown by a CCI method, to be auto-converted to a DataAccessException
        `SQLException` - if thrown by a ResultSet method, to be auto-converted to a DataAccessException
        `DataAccessException` - in case of custom exceptions
      See Also:
        `ConnectionFactory.getRecordFactory()`, `ConnectionFactory.getMetaData()`, `CciTemplate.execute(javax.resource.cci.InteractionSpec, RecordCreator, RecordExtractor)`